<?php

/**
 * The admin-specific functionality of the plugin.
 *
 * @link       https://faxosaurus.com
 * @since      1.0.0
 *
 * @package    Faxosaurus
 * @subpackage Faxosaurus/admin
 */

/**
 * The admin-specific functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the admin-specific stylesheet and JavaScript.
 *
 * @package    Faxosaurus
 * @subpackage Faxosaurus/admin
 * @author     Lee Gillentine <lee@faxosaurus.com>
 */
class Faxosaurus_Admin {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of this plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {

		$this->plugin_name = $plugin_name;
		$this->version = $version;

	}

	/**
	 * Register the stylesheets for the admin area.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_styles() {

		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in Faxosaurus_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The Faxosaurus_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */

		wp_enqueue_style( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'css/faxosaurus-admin.css', array(), $this->version, 'all' );

	}

	/**
	 * Register the JavaScript for the admin area.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_scripts() {

		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in Faxosaurus_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The Faxosaurus_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */

		wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/faxosaurus-admin.js', array( 'jquery' ), $this->version, false );

	}


	public function render_admin_page() {
		include 'partials/faxosaurus-admin-display.php';
	}

	public function register_menu() {
		add_menu_page(
			'Faxosaurus',
			'Faxosaurus',
			'manage_options',
			'faxosaurus',
			array( $this, 'render_admin_page' ),
		);
	}

	public function settings_api_init() {
		add_settings_section(
			'faxosaurus_section',
			'Faxosaurus Settings',
			array( $this, 'faxosaurus_settings_section_callback' ),
			'faxosaurus'
		);

		add_settings_field(
			'faxosaurus_api_key',
			'API Key',
			array( $this, 'faxosaurus_api_key_callback' ),
			'faxosaurus',
			'faxosaurus_section'
		);

		register_setting('faxosaurus', 'faxosaurus_api_key', [
			'sanitize_callback' => 'sanitize_text_field'
		]);
	}

	public function settings_rest_api_init() {
		register_setting('faxosaurus', 'faxosaurus_api_key', [
			'default' => '',
			'show_in_rest' => true,
			'type' => 'string',
			'sanitize_callback' => 'sanitize_text_field'
		]);
	}

	public function faxosaurus_settings_section_callback() {
		echo 'Faxosaurus is the easiest way to add intake management to your website. Enter your Faxosaurus API Key below';
	}

	public function faxosaurus_api_key_callback() {
		$value = get_option('faxosaurus_api_key');
		echo '<input type="text" name="faxosaurus_api_key" value="' . esc_attr($value) . '">';
	}
}